import java.util.*;

private int init = 0;
 
ArrayList<Spot> spots = new ArrayList<Spot>();

public class Spot{
 public float dirX;
 public float dirY;
 public float x;
 public float y;
 public float scale;
 private double change;
 public int size;
 public PGraphics g;
 public float alpha;
 private float alphacap;


 
 
 public Spot(int min, int max, float posX, float posY)
 {
   size = (int)random(min,max);
   size += size%2;
   x=posX;
   y=posY;
   
   dirX = random(-0.5,0.5);
   dirY = random(-0.5,0.5);
   scale = 0.9;
   alphacap = random(255);
   alpha = 0;
   
   g = createGraphics(size, size, P2D);
   g.beginDraw();
   g.background(0,255); // blur didnt work properly with (0,0)
   g.fill(255,255);
   g.noStroke();
   g.ellipse(size/2,size/2,(2*size)/3,(2*size)/3);
   g.filter(BLUR,map(size,0,max,4,15));
   change = map(size,600,0,0.001,0.005);
   if(change < 0.001)
     change = 0.001;
   g.loadPixels();
   float a;
   for(int y = g.height-1; y >= 0; y--)
      for(int x = g.width-1; x >=0 ; x--)
      {
         a=red(g.pixels[y*g.width + x]);
         g.pixels[y*g.width + x] = color(0,a);
      }
   g.updatePixels();
   
   g.endDraw();
 }
 
  public Spot(int min, int max)
 {
    this(min, max, random(width), random(height)); 
 }
 
 public Spot()
 {
   this(20,height, width, height);
 }
 
 
 public float scale()
 {
   if (scale > 1 || (scale < 0.8))
     change*=-1;
   scale+=change;
   return scale;
 }
 
 public boolean move(int w, int h) //false if its entirely outside of the window
 {
   if(alpha < alphacap)
     alpha+=0.5;

      x+=dirX;
      y+=dirY;
    
    if(x-size/2 > w || x+size/2 < 0)
      return false;
    if(y-size/2 > h || y+size/2 < 0)
      return false;
    return true;
 }
 
 public void reset()
 {
   x=random(width);
   y=random(height);
   
   dirX = random(-0.5,0.5);
   dirY = random(-0.5,0.5);
   alphacap = random(255);
   alpha = 0;
 }
 
 
 
}

private void init()
{  
 if(init>510)
   return;
   
  fill(242,69,69,255-(init/2));   
  text("don't you dare to close me", width/2, (0.95*height)/2);
  if(init == 1)
  {
    for(int i=0; i<(width+height)/12.5;i++)
    {
      spots.add(new Spot(50,300));
    }
    for(int i=0; i<(width+height)/300;i++)
    {
      spots.add(new Spot(300,500));
    }
    for(int i=0; i<(width+height)/750;i++)
    {
      spots.add(new Spot(500,1000));
    }
  }
  init++;
}

void setup()
{
  imageMode(CENTER);
  fullScreen(P2D);
  //size(1000, 500, P2D);
  strokeWeight(20);
  background(40,50,60);
  textAlign(CENTER);
  PFont font;
  font = createFont("FiraSans-UltraLight.otf", height/15);
  textFont(font, height/15);
  
  //add spots
  //init();
  
  
}

void mousePressed()
{
   spots.add(new Spot(50,600, mouseX, mouseY)); 
}

int change = 2; 

void draw()
{        
  background(40,50,60);
  init();
  
  Iterator<Spot> i = spots.iterator();
  while(i.hasNext())
  {
    Spot s = i.next();
    if(!s.move(width, height))
    {
      s.reset();
    }
    tint(255,s.alpha);
    float size = s.size*s.scale();
    image(s.g, s.x, s.y, size, size);
    
  }
}

    
void keyPressed() {
  if (key == 's' || key == 'S') saveFrame("_##.png");
}

    
    